Program Sierra_Unprotect ; {$S-}

{$M $4000, $4000, $4000 }

{Cold Turkey modified SUP on Nov 2014 to dump track 6
of the sierra keydisk to a file}

Uses
   Dos,Crt ;

Type
   ProtectBufferType = Array [0..8191] of Byte ;
   BufferInUseType   = (Normal,Spare) ;

Var
   WhereDMA      : Word ;
   BufferInUse   : BufferInUseType ;
   ProtectTrack  : Array [Normal .. Spare] of ProtectBufferType ;
   InOutFile     : File ;
   SomethingUnprotected : Boolean ;

   
Procedure CheckTrack6 ;

Var
   Retries, Indx : Integer ;
   Regs          : Registers ;
   SaveDBT       : Pointer ;
   ChkSum        : Word ;

Const
   DiskBaseTable : Array[1..11] of Byte =
                         ($CF,$02,$25,$06,$01,$2A,$FF,$50,$F6,$19,$04) ;

Begin

   ClrScr ;
   WriteLn ('Please insert your ORIGINAL game diskette 1 in drive A:') ;
   WriteLn ('This diskette MUST be write protected.') ;
   WriteLn ('Hit the <ENTER>-key when ready... ') ;
   WriteLn ;

   Repeat until Not KeyPressed ;
   Repeat until ReadKey = #13 ;

   FileMode := 0 ;
   Assign (InOutFile,'A:\CPC.COM');
   {$I-}
   Reset (InoutFile,1);
   {$I+}
   If IOResult <> 0 then
       Begin
          WriteLn ('That did not look like your ORIGINAL game diskette.');
          WriteLn ;
          Halt ;
       End ;
    Close (InOutFile);
    FileMode := 2 ;

    GetIntVec($1E,SaveDBT);
    SetIntVec($1E,@DiskBaseTable);
    Retries := 3 ;
    With Regs do
       Repeat

          AH := 0 ; { Reset diskette system }
          If Retries <> 3 then
             Intr ($13,Regs) ;

          AH := 2 ; { Read operation }
          DL := 0 ; { Drive }
          DH := 0 ; { Head  }
          CH := 6 ; { Track }
          CL := 1 ; { Sector }
          AL := 1 ; { Number of Sectors }
          ES := Seg(ProtectTrack[BufferInUse]) ;
          BX := Ofs(ProtectTrack[BufferInUse]) ;
          Intr ($13,Regs) ;
          Dec (Retries) ;

       Until (AH = $10) or (Retries = 0) ;

    SetIntVec($1E,SaveDBT);

    ChkSum := 0 ;

    If (Regs.AH = $10) then
       For Indx := 0 to 511 do
          ChkSum := ChkSum + ProtectTrack[BufferInUse][Indx] ;

    If (ChkSum <> 28) then
       Begin
          WriteLn ('Sorry, but the copy protection check failed.');
          WriteLn ('Unable to continue.');
          WriteLn ;
          Halt ;
       End ;

    WriteLn ('Thankyou.');
    WriteLn ;

End ; { Procedure CheckTrack6 }

Begin { Program Sierra_Unprotect }
   {Run the function to read the key from track 6}
   CheckTrack6 ;
   
   {After the track has been read, write it to a file}
   FileMode := 1 ; {0 = read, 1 = write, 2 = readwrite}
   Assign ( InOutFile , 'c:\sierra.key' ) ;
   Rewrite (InOutFile,1);  {this reads FileMode and sets it on the file}
   BlockWrite(InOutFile,ProtectTrack[BufferInUse],8192); {write the sector to disk!}
   Close(InOutFile);

End . { Program Sierra_Unprotect }